//
//  FAMessage.h
//  FollowApps
//
//  Created by Raphaël El Beze on 04/01/2017.
//  Copyright © 2017 Followanalytics. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UserNotifications/UserNotifications.h>

@interface FAMessage : NSObject

@property(nonatomic, assign, readonly) BOOL isRead;
@property(nonatomic, assign, readonly) BOOL isPush;
@property(nonatomic, assign, readonly) BOOL isSilent;
@property(nonatomic, assign, readonly) BOOL isInApp;

@property(nonatomic, retain, readonly, nonnull) NSString* identifier;
@property(nonatomic, retain, readonly, nonnull) NSDate* date;

@property(nonatomic, retain, readonly, nullable) NSString* notificationId;
@property(nonatomic, retain, readonly, nullable) NSString* type;

@property(nonatomic, retain, readonly, nullable) NSString* title;
@property(nonatomic, retain, readonly, nullable) NSString* body;
@property(nonatomic, retain, readonly, nullable) NSString* subtitle;

@property(nonatomic, retain, readonly, nullable) NSString* contentUrl;

@property(nonatomic, retain, readonly, nullable) NSString* layout;
@property(nonatomic, retain, readonly, nullable) NSString* openingUrl;

@property(nonatomic, retain, readonly, nonnull) NSDictionary* parameters;

@property(nonatomic, retain, readonly, nullable) NSString* category;
@property(nonatomic, retain, readonly, nullable) NSDictionary* rawData;

- (void)displayInApp;

@end
